# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Hook-LexWrap
Version:	0.26
Release:	19.%{__distinit}%{__distvers}
Summary:	Lexically scoped subroutine wrappers
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Hook-LexWrap
Source0:	https://cpan.metacpan.org/modules/by-module/Hook/Hook-LexWrap-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(overload)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod) >= 1.14
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
Hook::LexWrap allows you to install a pre- or post-wrapper (or both)
around an existing subroutine. Unlike other modules that provide this
capacity (e.g. Hook::PreAndPost and Hook::WrapSub), Hook::LexWrap
implements wrappers in such a way that the standard `caller' function
works correctly within the wrapped subroutine.

%prep
%setup -q -n Hook-LexWrap-%{version}

%build
PERL_MM_FALLBACK_SILENCE_WARNING=1 perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING README demo/
%{perl_vendorlib}/Hook/
%{_mandir}/man3/Hook::LexWrap.3*

%changelog
* Sun Apr 23 2023 Paul Howarth <paul@city-fan.org> - 0.26-19
- Use SPDX-format license tag
- Use %%license unconditionally

* Sat Jun  1 2019 Paul Howarth <paul@city-fan.org> - 0.26-8
- Modernize spec
  - Switch upstream from search.cpan.org to metacpan.org
  - BR: perl-generators unconditionally
  - BR: perl-interpreter rather than perl
  - Don't explicitly clean buildroot in %%install section
  - Drop explicit %%clean section
  - Drop legacy BuildRoot: and Group: tags

* Thu Feb 23 2017 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - Properly wrap CORE::caller for @DB::args (CPAN RT#103186)

* Thu Aug 25 2016 Paul Howarth <paul@city-fan.org> - 0.25-5
- BR: perl-generators where available
- Simplify find command using -delete

* Tue Oct 21 2014 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25
  - Fix for perl 5.21.4: ensure barewords are parsed properly (CPAN RT#99021,
    Perl RT#122757)
- This release by ETHER → update source URL
- Package new upstream documentation and license file
- No longer need to fix line endings
- Classify buildreqs by usage
- Silence bogus warning about not having bleeding edge build modules

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.24-6
- Drop %%defattr, redundant since rpm 4.4

* Fri Jun 22 2012 Paul Howarth <paul@city-fan.org> - 0.24-3
- BR: perl(Carp)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 0.24-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Sep 24 2010 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
  - Makefile.PL fixed
  - New test added
- Drop patch for CPAN RT#59725, problem resolved upstream

* Tue Jul 27 2010 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Add Build.PL
  - Better support for debugger
- Upstream distribution changed from zipfile to tarball
- Fix line endings on documentation
- No longer need to fix permissions on documentation
- Include demo directory as %%doc
- Fix logic error in Makefile.PL for ExtUtils::MakeMaker < 6.31 (CPAN RT#59725)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 0.22-5
- Rebuild for perl 5.12.1 in Rawhide

* Fri Jun  4 2010 Paul Howarth <paul@city-fan.org> - 0.22-4
- Fix dist tag for RHEL-6 Beta

* Sun Feb 21 2010 Paul Howarth <paul@city-fan.org> - 0.22-3
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Thu Sep 10 2009 Paul Howarth <paul@city-fan.org> - 0.22-2
- Define RPM macros in global scope

* Fri Dec 19 2008 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22 (code cleanup)

* Mon Nov 10 2008 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
- New upstream maintainer => new source URL
- Add buildreqs perl(Test::More) and perl(Test::Pod)

* Mon Sep  1 2008 Paul Howarth <paul@city-fan.org> - 0.20-6
- Import from Fedora

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.20-5
- Rebuild for perl 5.10 (again)

* Sat Jan 12 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.20-4.2
- rebuild for new perl

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 0.20-4.1
- correct license tag
- add BR: perl(ExtUtils::MakeMaker)

* Fri Sep  8 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-4
- Rebuild for FC6.

* Fri Feb 17 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-3
- Rebuild for FC5 (perl 5.8.8).

* Fri Sep  9 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-2
- Comment about license files location.

* Fri Aug 26 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-1
- First build.
